<?php
/*--------------------------------------------------------------------*
 | Copyright (c) 2010-2013 Vayer Software Ltd. - All Rights Reserved. |
 *--------------------------------------------------------------------*/

session_start();
require "common.php";
require "dbninja.php";

$err = array();
if (version_compare(PHP_VERSION, '5.3.0') < 0)
	$err[] = "- PHP version 5.3.0 or higher is required. Your version is ".PHP_VERSION.".";
if (!extension_loaded('mysqli'))
	$err[] = "- PHP installation is missing the 'mysqli' extension";
if (!isset($_SESSION))
	$err[] = '- Support for sessions is disabled';
if (!file_exists('_users'))
	$err[] = "- Directory '_users' does not exist";
?>
<!DOCTYPE html>
<html>
<head>
<title>DbNinja | Setup</title>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
<link rel="stylesheet" type="text/css" href="css/styles.css" />
<link rel="stylesheet" type="text/css" href="css/login.css" />
<script>
function dis(i, f) { document.getElementById(i).disabled = f; document.getElementById(i).style.opacity = (f ? .7 : 1); }
</script>
</head>
<body style="background-color:#fdfdfd">
<script>
if (location.protocol=='http:') document.write('<div id="sslwarn" class="center">You are not using a secure connection and data is sent unencrypted. You are advised to setup DbNinja over HTTPS connection.</div>');
</script>
<table style="width:100%;height:100%"><tr><td>
<div id="setupBox" class="shadBox roundTop roundBottom shadow center">
<?php
	$p = @$_POST['p'];
	echo $p ?
		'<p><img src="images/logo_tiny.png" alt="DbNinja" /></p>' :
		'<p style="text-align:center"><img src="images/logo.png" alt="DbNinja" /></p>';
	if ($err) {
		echo '<p class="title">Setup can\'t continue:</p><p>'.(is_array($err) ? implode("<br />\n", $err) : $err).'</p>'.
			'<a href="http://www.dbninja.com/?page=resources&z=102" target="_blank">Click here for details</a></p>';
	} else {
		if ($p=='') {
?>
<form method="POST" style="text-align:center">
	<input type="hidden" name="p" value="st1" />
	<p class="title">Welcome to DbNinja v<?php echo VERSION; ?> Setup!</p>
	<p>You must agree with the following terms of use in order to continue:</p>
	<iframe src="license.html" style="width:540px;height:200px;border:2px solid #adadad"></iframe>
	<p style="margin-top:10px">
		<label><input id="c" type="checkbox" onclick="dis('s',!checked)" />I agree</label>
		&nbsp;&nbsp;&nbsp;<input id="s" type="submit" value="Begin Setup" />
	</p>
</form>
<script>document.getElementById('c').checked=false;dis('s',1);</script>
<?php
		}
		$err = False;
		if ($p=='st2') {
			if (!file_exists('_users/admin')) {
				$p = 'st1';
				$err = True;
			}
		} else if ($p=='st3') {
            if (strlen($_POST['passwd'])<6) {
		        $p = 'st2';
		        $err = True;
	        }
		}
		if ($p=='st1') {
?>
<form method="POST">
	<input type="hidden" name="p" value="st2" />
	<?php echo $err ? '<p style="color:red;font-weight:bold">Sorry, still can\'t find directory \'admin\'</p>' : '' ?>
	<p>We need to make sure you are the owner of this server. Please create a directory named <b>admin</b> inside <b><?php echo basename(getcwd()) ?>/_users</b>.
	When done click "Continue".</p>
	<div style="text-align:center"><input id="s" type="submit" value="Continue"" /></div>
</form>
<?php
		}
		if ($p=='st2') {
?>
<form method="POST">
	<input type="hidden" name="p" value="st3" />
	<?php echo $err ? '<p style="color:red;font-weight:bold">This password is too short. Please use at least 6 characters.</p>' : '' ?>
	<p>Please choose a strong password for your account. We recommended you use capitals, numbers, and symbols.</p>
	<div style="text-align:center">
	    <input id="passwd" name="passwd" type="text" />
	    <input id="s" type="submit" value="Continue" />
    </div>
</form>
<script>document.getElementById('passwd').focus();</script>
<?php
		}
		if ($p=='st3') {
				$uname = 'admin';
				$upath = '_users/'.$uname;
				$paswd = sha1(trim($_POST['passwd']));
				if (@file_put_contents(
					"{$upath}/userdata.php",
					"<?php\nreturn ".var_export(
						array(
							'uid'=>randString(20),
							'passwd'=>$paswd
						),
					TRUE).";\n?>"
				) && (file_exists("{$upath}/temp") || mkdir("{$upath}/temp"))) {
?>
<div style="text-align:center">
	<p style="font-weight:bold">Congratulations, your account has been created!</b></p>
	<p>Use username <b style="color:red">admin</b> and your password to log-in.</p>
	<p><a href="./index.php">Click here to log-in to DbNinja</a></p>
</div>
<?php
				} else {
?>
<form method="POST">
	<input type="hidden" name="p" value="st2" />
	<p style="color:red;font-weight:bold;display:inline">Directory 'admin' does not have the appropriate writing permissions.</p>
	Please correct and click "Continue".
	<a href="http://www.dbninja.com/?page=resources&z=102" target="_blank">Click here for details</a><br />
	<p style="margin-top:10px;text-align:center"><input id="s" type="submit" value="Continue" /></p>
</form>
<?php
				}
		}
	}
?>
</div>
</td></tr></table>
<iframe src="_users/secure.html?rnd=<?php echo rand()?>" style="display:none"></iframe>
</body>
</html>